/*
 * AppController.j
 * TwitterSearch
 *
 * Created by Lukáš Hurych on February 9, 2011.
 * Copyright 2011, abdoc.net All rights reserved.
 */

@import <Foundation/CPObject.j>
@import "SearchResultCell.j"


@implementation AppController : CPObject
{
	CPCollectionView list;
	CPTextField textField;
}

- (void)applicationDidFinishLaunching:(CPNotification)aNotification
{
	var theWindow = [[CPWindow alloc] initWithContentRect: CGRectMakeZero() styleMask: CPBorderlessBridgeWindowMask],
	contentView = [theWindow contentView];
	
	var button = [[CPButton alloc] initWithFrame: CGRectMake(420.0,37.0,80.0,24.0)];
	[button setTitle: @"Hledej"];
	[button setAction:@selector(newSearch:)];
	
	textField = [CPTextField textFieldWithStringValue: @"" placeholder: @"Zadej řetězec" width: 390.0];
	[textField setFrameOrigin:CGPointMake(30.0, 35.0)];
	
	var resultsArea = [[CPScrollView alloc] initWithFrame: CGRectMake(34.0, 67.0, 380.0, 500.0)];
	[resultsArea setAutohidesScrollers: YES];
	
	var searchResultItem = [[CPCollectionViewItem alloc] init];
	[searchResultItem setView: [[SearchResultCell alloc] initWithFrame:CGRectMakeZero()]];
	
	list = [[CPCollectionView alloc] initWithFrame: [resultsArea bounds]];
	
	[list setDelegate: self];
	[list setItemPrototype: searchResultItem];
	
	[list setMinItemSize: CGSizeMake(300.0, 60.0)];
	[list setMaxItemSize: CGSizeMake(380.0, 60.0)];
	[list setAutoresizingMask: CPViewWidthSizable];
	
	[resultsArea setDocumentView: list];
	
	[contentView addSubview: resultsArea];
	[contentView addSubview: textField];
	[contentView addSubview: button];
	
	[theWindow orderFront: self];
}

- (void)newSearch:(id)sender
{
	var string = [textField stringValue];
	var request = [CPURLRequest requestWithURL:"http://search.twitter.com/search.json?q=" + encodeURIComponent(string)];
	twitterConnection = [CPJSONPConnection connectionWithRequest:request callback:"callback" delegate:self];
}

- (void)connection:(CPJSONPConnection)aConnection didReceiveData:(CPString)data
{
	[self showSearchResults:data.results];
}

- (void)connection:(CPJSONPConnection)aConnection didFailWithError:(CPString)error
{
	alert(error);
}

- (void)showSearchResults:(CPArray)results
{
	[list setContent:results];
}

@end